// Model Simulation

var c y inv yw rer lopg r pi rk q mpc k nw n w mc ay z d rw piw tot pih pim rf s x;// ex g ;
varexo  em eyw erw epiw ez eay;// eg;

parameters a sigma tetha pshi deltha gamma etha betha phih phim alphaa pshid c_y k_y inv_y k_nw rhoy rhorw rhopiw rhoz rhoay betha0 rk_bar betha1 betha2 nu betha3 muex rhog; //betha3 


load parameterfile
set_param_value('a',a)
set_param_value('sigma',sigma)
set_param_value('tetha',tetha)
set_param_value('pshi',pshi)
set_param_value('deltha',deltha)
set_param_value('gamma',gamma)
set_param_value('etha',etha)
set_param_value('betha',betha)
set_param_value('phih',phih)
set_param_value('phim',phim)
set_param_value('alphaa',alphaa)
set_param_value('pshid',pshid)
set_param_value('c_y',c_y)
set_param_value('k_y',k_y)
set_param_value('inv_y',inv_y)
set_param_value('k_nw',k_nw)
set_param_value('rhoy',rhoy)
set_param_value('rhorw',rhorw)
set_param_value('rhopiw',rhopiw)
set_param_value('rhoz',rhoz)
set_param_value('rhoay',rhoay)
set_param_value('betha0',betha0)
set_param_value('rk_bar',rk_bar)
set_param_value('betha1',betha1)
set_param_value('betha2',betha2)
set_param_value('nu',nu)
set_param_value('betha3',betha3)
set_param_value('muex',muex)
set_param_value('rhog',rhog)



model (linear);


    
//consumption

c=c(+1)-(1/sigma)*(r-pi(+1));

//UIP
r-pi(+1)=(rw-piw(+1))+pshid*d+z+rer(+1)-rer;

//rer(+1)=rer+(r-pi(+1))-(rw-piw(+1))-pshid*d-z;

//Labor

n=(w-sigma*c)*1/(etha);

// Wage

w=y+mc-n-((rer-lopg)*a /(1-a));

//Marginal productivity of K

mpc=y+mc-k(-1)-((rer-lopg)*a /(1-a));

// CPI

pi=betha*pi(+1)+((1-a)*(1-betha*phih)*(1-phih)*mc/phih)+(a*(1-betha*phim)*(1-phim)*lopg/phim);

// Production fonction

y=alphaa*k(-1)+(1-alphaa)*n+ay;

// Capital accumulation

k=(1-deltha)*k(-1)+deltha*inv;

// Capital price

q=pshi*(inv-k(-1));
    
// Entrepreneur's return on capital

rk(+1)=rw+pshid*d+z-piw(+1)-gamma*(nw(+1)-q-k)+rer(+1)-rer;
//rk=rw(-1)-piw-gamma*(nw-q(-1)-k(-1))+rer-rer(-1);

rk(+1)=(1-((1-deltha)/rk_bar))*mpc(+1)+((1-deltha)/rk_bar)*q(+1)-q;

//Entrpreneur's Net Worth

nw =nu*rk_bar*(k_nw*rk+(1-k_nw)*(rw+pshid*d+z+rer-rer(-1)-piw)+gamma*(1-k_nw)*(q(-1)+k(-1))+(1+gamma*(k_nw-1))*nw(-1));

//Aggregate demand    
   
y=c_y*(1-a)*c+inv_y*(1-a)*inv+a*yw+tetha*a*((2-a)/(1-a))*rer-(tetha*a*lopg/(1-a));
    
//debt accumulation

d=(1/betha)*d(-1)+y-(c_y*c+inv_y*inv)-a*(rer-lopg)/(1-a);


//Others variables

tot=(1/(1-a))*(rer-lopg);
lopg-lopg(-1)=s-s(-1)+piw-pim;
pih=betha*pih(+1)+((1-betha*phih)*(1-phih)*mc/phih);
pim=betha*pim(+1)+((1-betha*phim)*(1-phim)*lopg/phim);
yw=rhoy*yw(-1)-eyw;
rw=rhorw*rw(-1)+erw;
piw=rhopiw*piw(-1)+epiw;
z=rhoz*z(-1)+ez;
ay=rhoay*ay(-1)+eay;
rf=r-pi(+1);
s-s(-1)=rer-rer(-1)-piw+pi;
x=s-s(-1);


//Monetary policy

r=(1-betha0)*(betha1*pi+betha2*y)+betha0*r(-1)+em;



end;



steady;
check;

shocks; 

var eyw; stderr 0.02;
            
end;

stoch_simul(periods=2000,irf=0,nocorr) c n y inv rer x r rf pi tot nw ;





